//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSandyBrown
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;  // Time frame to use
extern int    Length             = 14;              // Calculation length
extern ENUM_APPLIED_PRICE Price  = PRICE_CLOSE;     // Price to use
extern double Lambda             = 5;               // Lambda
extern bool   alertsOn           = false;    // Turn alerts on?
extern bool   alertsOnCurrent    = true;     // Alerts on current (still opened) bar?
extern bool   alertsMessage      = true;     // Alerts should show pop-up message?
extern bool   alertsSound        = false;    // Alerts should play a sound?
extern bool   alertsEmail        = false;    // Alerts should send email?
extern bool   alertsPushNotif    = false;    // Alerts should send push notification?
extern bool   Interpolate        = true;     // Interpolate in multi time frame mode

//
//
//
//
//

double mom[];
double rema[];
double remda[];
double remdb[];
double slope[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,rema);
      SetIndexBuffer(1,remda);
      SetIndexBuffer(2,remdb);
      SetIndexBuffer(3,slope);
         indicatorFileName   = WindowExpertName();
         returnBars          = TimeFrame==-99;
         TimeFrame           = MathMax(TimeFrame,_Period);
         IndicatorShortName(timeFrameToString(TimeFrame)+" Regularized ema ("+(string)Length+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rema[0] = limit+1; return(0); }
         if (TimeFrame!=Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            if (slope[limit]==-1) CleanPoint(limit,remda,remdb);
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  rema[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Lambda,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif,0,y);
                  remda[i] = EMPTY_VALUE;
                  remdb[i] = EMPTY_VALUE;
                  if (i>=Bars-1) continue;
                  slope[i] = slope[i+1];
                     if (rema[i] > rema[i+1]) slope[i] =  1;
                     if (rema[i] < rema[i+1]) slope[i] = -1;
                     
                     //
                     //
                     //
                     //
                     //
                     
                      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                     //
                     //
                     //
                     //
                     //

                     int n,s; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;
                        for(s = 1; i+n<Bars && i+s<Bars && s<n; s++) 
  	                        rema[i+s] = rema[i] + (rema[i+n] - rema[i])* s/n;
            }       
   	      for(i=limit; i>=0; i--) if (slope[i]==-1) PlotPoint(i,remda,remdb,rema);
            return(0);
         }

   //
   //
   //
   //
   //

   double alpha = 2.0 / (1.0*Length);      
   double regf1 = (1.0+Lambda*2.0);
   double regf2 = (1.0+Lambda);
   if (slope[limit]==-1) CleanPoint(limit,remda,remdb);
   for(i=limit; i>=0; i--) 
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if (Bars-i>2)
            rema[i]  = (regf1*rema[i+1]+alpha*(price-rema[i+1])-Lambda*rema[i+2])/regf2;
      else  rema[i]  = price;
      if (i>=Bars-1) continue;
            slope[i] = slope[i+1];
            remda[i] = EMPTY_VALUE;
            remdb[i] = EMPTY_VALUE;
            if (rema[i] > rema[i+1]) slope[i] =  1;
            if (rema[i] < rema[i+1]) slope[i] = -1;
   	      if (slope[i]==-1) PlotPoint(i,remda,remdb,rema);
   }  
   manageAlerts(); 
   return(0);
}


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar]== 1) doAlert(whichBar,"slope changed to up");
         if (slope[whichBar]==-1) doAlert(whichBar,"slope changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" regularized ema "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," regularized ema "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," regularized ema "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}